/*
		Gery Casiez
		http://www.lifl.fr/~casiez
		
		echoMouse.cpp
		
		September 2010		
*/
#ifdef _WIN32
#include <windows.h>
#endif
#include "echoMouse.h"

EchoMouse::EchoMouse(void)
{
  
}


int EchoMouse::Init() 
{
  // Open the device using the VID, PID,
  // and optionally the Serial number.
  handle = hid_open(0x45e, 0x40, L"EchoMouse");//hid_open(0x4d8, 0x3f, NULL);
  if (handle == NULL) {
    std::cerr << "Problem opening EchoMouse" << std::endl;
    return -1;
  }
  return 0;
}

int EchoMouse::Send(unsigned char x, unsigned char y, unsigned char scroll, bool leftClick, bool middleClick, bool rightClick)
{
  // http://www.computer-engineering.org/ps2mouse/
  unsigned char buttons = 0x8;
  if (leftClick) buttons |= 0x1;
  if (rightClick) buttons |= 0x2;
  if (middleClick) buttons |= 0x4;

  // Output reports
  #ifndef _WIN32
	unsigned char data[4] = {x, y, scroll, 0};
	//data[3] = buttons;
	int res = hid_write(handle, data, sizeof(data));
  // Feature reports
  #else
	// Always keep the first byte equal to 0!
	unsigned char data[5] = {0, x, y, scroll, 0};
	data[4] = buttons;
	int res= hid_send_feature_report(handle, data, sizeof(data));
  #endif
  return res;
}

EchoMouse::~EchoMouse(void)
{

}



