#include <math.h>
#include <stdio.h>
#include "echoMouse.h"
#ifdef WIN32
	#include <windows.h>
#endif

EchoMouse echoMouse;


void circle() {
  float radius = 5.0;
  for (float theta=0.0; theta<=360.0*6.0; theta+=1) {
    int ret = echoMouse.Send(radius*cos(theta*3.1415/180.0),radius*sin(theta*3.1415/180.0),0,false, false, false);
    if (ret <= 0) {
        std::cerr << "Sending failed! (" << ret << ") " << std::endl;
    }
	// When using feature reports, a sleep is required to avoid loosing reports
	// Try different values to see how fast you can go without loosing reports
	// Feature reports are required on Windows
	// Output and feature reports work on OSX and Linux (=> prefer using output reports)

	#ifdef _WIN32
		Sleep(8);
    #else
        usleep(10000);
    #endif
  }
}

void move() {
    while (1) {
        echoMouse.Send(1, 0, 0, false, false, false);
        usleep(500);
    }
}

void scroll(int amt) {
    while (1) {
        // Must alternate X pos like this, or the cursor slams into the bottom of the screen
        // Not sure why yet...
        int ret = echoMouse.Send(-1, 0, 0, false, false, false);
        ret += echoMouse.Send(1,0, 0, false, false, false);
        if (ret <= 0) {
            std::cerr << "Sending failed! (" << ret << ")" << std::endl;
        }
        #ifdef _WIN32
            Sleep(32);
        #else
            usleep(100000);
        #endif
    }
}

void leftClick() {
  echoMouse.Send(0,0,0, true, false, false);
  echoMouse.Send(0,0,0, false, false, false);
}


int main(int argc, char* argv[]) {

  if (echoMouse.Init() != 0) {
    std::cerr << "Problem opening EchoMouse" << std::endl;
    return -2;
  }

  //int amt = atoi(argv[1]);

  //scroll(amt);
    move();

  return 0;
}
