EchoMouse version 0.9 - 04/02/2012
 + Scroll Gain Inspection

Related Papers
==============
1. Géry Casiez and Nicolas Roussel. 2011. No more bricolage! methods and tools to characterize, replicate and compare pointing transfer functions. In Proceedings of the 24th annual ACM symposium on User interface software and technology (UIST '11). ACM, New York, NY, USA, 603-614. DOI=10.1145/2047196.2047276 http://doi.acm.org/10.1145/2047196.2047276

2. Philip Quinn, Andy Cockburn, Géry Casiez, Nicolas Roussel, and Carl Gutwin. Exposing and understanding scrolling transfer functions. In Proceedings of the 25th annual ACM symposium on User interface software and technology (UIST '12). ACM, New York, NY, USA, 341--350. DOI=10.1145/2380116.2380161 http://doi.acm.org/10.1145/2380116.2380161

Index
=====
* `Board/` - EchoMouse simulator circuit diagram
* `Demo/` - Example EchoMouse tool (required HIDAPI)
* `doc/` - MicroChip documentation
* `firmware/` - EchoMouse firmwware for the PIC18LF14K50 (see below)
* `Utils/HIDReportTracer/` - Mac OS X HID Report logger
* `Utils/ScrollGainInsepctor/` - Mac OS X & Windows Scroll Gain logger

EchoMouse Firmware
==================
Uses MicroChip PICkit 2 to program the PIC18LF14K50 but other programmers work too: MPLAB PM3, MPLAB REAL ICE, MPLAB ICD 2, MPLAB ICD 3, PICkit 3 

Compiling & Flashing
--------------------
ONLY possible on Windows:

1. Download required software
  * MPLAB IDE (tested with version 8.83 - filename: MPLAB_IDE_8_83.zip) on http://www.microchip.com
  * MPLAB C18 Academic (tested with version 3.31 - filename: MPLAB-C18-Academic-v3_31.exe)
2. Install MPLAB IDE then MPLAB C18
3. Open echomouse.mcp
4. You can now compile and flash the device

Burn EchoMouse firmware on the PIC (Windows, Linux, Mac OS X):

1. Download and install PICkit 2 programmer software (tested with version 2.61 - filename PICKit2v2.61.00Setup_A.zip)
2. File > Import Hex
3. Locate EchoMouse.hex
4. Hit the Write button. If "Programming Successful" appears, you're done!
  * Note: also successfully tested using pk2cmd (available from www.microchip.com) on Mac OS X (10.6.8):
     pk2cmd -F EchoMouse.hex -M -P

Editing
-------
The EchoMouse can simulate specific hardware mice (such as a Microsoft or Logitech mouse) in order to get a vendor's associated drivers to recognise the EchoMouse. This is done by editing the device descriptor in the `firmware/usb_descriptors.c` file (search for the `device_dsc` variable, around line 169).

Demo
====
Based on HIDAPI: http://www.signal11.us/oss/hidapi/

API slightly modified to work on Windows (see: https://github.com/partylemon/hidapi)

Scroll Gain Inspector
=====================
Sends scrolling events to the EchoMouse and then observes the resultant scrolling events sent by the operating system to applications.

Compiling
---------
Apple Xcode (4+) and Microsoft Visual Studio (2012+) projects are supplied. The shared C++ source requires a compiler and standard library with C++11 support (tested with MSVC12 and Apple clang version 4.0).

Requires the (slightly modified) HIAPI library (see "Demo" section above).

Editing
-------
The scrolling behaviour is controlled through `ExperimentalScroller` and `ScrollingActivity` subclasses (see `experimental.hpp` and `activities.hpp`). The actual behaviour invoked is controlled through either the `-[WindowController startScrolling]` method (OS X) or `StartScrolling()` (Windows), with output logged to the console.

